Package org.apache.lucene.search

## Class KnnVectorQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.KnnFloatVectorQuery
    - - org.apache.lucene.search.KnnVectorQuery

-     @Deprecated
      public class KnnVectorQuery
      extends KnnFloatVectorQuery

  Deprecated.
  use `KnnFloatVectorQuery` instead
  Uses `KnnVectorsReader.search(String, float[], KnnCollector, Bits)` to perform nearest neighbour search.

  This query also allows for performing a kNN search subject to a filter. In this case, it first executes the filter for each leaf, then chooses a strategy dynamically:

  - If the filter cost is less than k, just execute an exact search
  - Otherwise run a kNN search subject to the filter
  - If the kNN search visits too many vectors without completing, stop and run an exact search

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected String` | `field` |
    `protected int` | `k` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `KnnVectorQuery​(String field, float[] target, int k)` | Deprecated.
    `KnnVectorQuery​(String field, float[] target, int k, Query filter)` | Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected TopDocs` | `exactSearch​(LeafReaderContext context, DocIdSetIterator acceptIterator)` |
    `String` | `getField()` |
    `Query` | `getFilter()` |
    `int` | `getK()` |
    `protected KnnCollectorManager` | `getKnnCollectorManager​(int k, IndexSearcher searcher)` |
    `protected TopDocs` | `mergeLeafResults​(TopDocs[] perLeafResults)` | Merges all segment-level kNN results to get the index-level kNN results.
    `Query` | `rewrite​(IndexSearcher indexSearcher)` | Expert: called to re-write queries into primitive queries.
    `void` | `visit​(QueryVisitor visitor)` | Recurse through the query tree, visiting any child queries.

    - ### Methods inherited from class org.apache.lucene.search.KnnFloatVectorQuery

      `approximateSearch, equals, getTargetCopy, hashCode, toString`

    - ### Methods inherited from class org.apache.lucene.search.Query

      `classHash, createWeight, rewrite, sameClassAs, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### field

          protected final String field

    - #### k

          protected final int k

  - ### Constructor Detail

    - #### KnnVectorQuery

          public KnnVectorQuery​(String field,
                                float[] target,
                                int k)

      Deprecated.

    - #### KnnVectorQuery

          public KnnVectorQuery​(String field,
                                float[] target,
                                int k,
                                Query filter)

      Deprecated.

  - ### Method Detail

    - #### rewrite

          public Query rewrite​(IndexSearcher indexSearcher)
                        throws IOException

      Description copied from class: `Query`
      Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

      Callers are expected to call `rewrite` multiple times if necessary, until the rewritten query is the same as the original query.

      The rewrite process may be able to make use of IndexSearcher's executor and be executed in parallel if the executor is provided.

      However, if any of the intermediary queries do not satisfy the new API, parallel rewrite is not possible for any subsequent sub-queries. To take advantage of this API, the entire query tree must override this method.

      Overrides:
        `rewrite` in class `Query`
      Throws:
        `IOException`
      See Also:
        `IndexSearcher.rewrite(Query)`

    - #### getKnnCollectorManager

          protected KnnCollectorManager getKnnCollectorManager​(int k,
                                                               IndexSearcher searcher)

    - #### exactSearch

          protected TopDocs exactSearch​(LeafReaderContext context,
                                        DocIdSetIterator acceptIterator)
                                 throws IOException

      Throws:
        `IOException`

    - #### mergeLeafResults

          protected TopDocs mergeLeafResults​(TopDocs[] perLeafResults)

      Merges all segment-level kNN results to get the index-level kNN results.

      The default implementation delegates to `TopDocs.merge(int, TopDocs[])` to find the overall top `k`, which requires input results to be sorted.

      This method is useful for reading and / or modifying the final results as needed.

      Parameters:
        `perLeafResults` - array of segment-level kNN results.
      Returns:
        index-level kNN results (no constraint on their ordering).
      WARNING: This API is experimental and might change in incompatible ways in the next release.

    - #### visit

          public void visit​(QueryVisitor visitor)

      Description copied from class: `Query`
      Recurse through the query tree, visiting any child queries.
      Specified by:
        `visit` in class `Query`
      Parameters:
        `visitor` - a QueryVisitor to be called by each query in the tree

    - #### getField

          public String getField()

      Returns:
        the knn vector field where the knn vector search happens.

    - #### getK

          public int getK()

      Returns:
        the max number of results the KnnVector search returns.

    - #### getFilter

          public Query getFilter()

      Returns:
        the filter that is executed before the KnnVector search happens. Only the results accepted by this filter are returned by the KnnVector search.